=== debian/changelog ===
libc++ (3.7.0-1ubuntu0.1) xenial; urgency=medium

  * Fix error int the string header in c++11 mode (LP: #1610168).

 -- Sergey Vidyuk <Sir-VestniK@yandex.ru>  Sat, 24 Jun 2017 18:09:34 +0700

libc++ (3.7.0-1) unstable; urgency=medium

  * New upstrem release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 06 Sep 2015 12:02:37 +0200

libc++ (3.6.2-1) unstable; urgency=medium

  * New upstream release
  * Upload in unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 03 Aug 2015 14:23:53 +0200

libc++ (3.6-1~exp1) experimental; urgency=medium

  * New upstream release
  * Add support for kfreebsd. Thanks to Jan Henke (Closes: #780106)
  * Standards-Version updated to 3.9.6

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 17 Mar 2015 18:48:20 +0100
