=== debian/control ===
Source: libc++
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
 Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 9.0.0), clang, dh-exec
Standards-Version: 3.9.6
Section: libs
Homepage: http://libcxx.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/libcxx/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/libcxx/trunk/

Package: libc++1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: clang
Description: LLVM C++ Standard library
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}, libc++-helpers
Provides: libstdc++-dev
Description: LLVM C++ Standard library (development files)
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.

Package: libc++-test
Section: libs
Architecture: any
Depends: libc++1 (= ${binary:Version}), ${misc:Depends}
Replaces: libc++-src (<< 1.0~svn199600-1)
Breaks: libc++-src (<< 1.0~svn199600-1)
Description: LLVM C++ Standard library (test cases)
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.
 .
 This package contains the test cases of libc++ library.

Package: libc++abi1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LLVM low level support for a standard C++ library
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Description: LLVM low level support for a standard C++ library (development files)
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .

Package: libc++abi-test
Section: libs
Architecture: any
Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
Replaces: libc++abi-src (<< 1.0~svn199600-1)
Breaks: libc++abi-src (<< 1.0~svn199600-1)
Description: libc++abi test cases
 libc++abi is a new implementation of low level support for a standard C++
 library.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Provide a portable sublayer to ease the porting of libc++
 .
 Test cases of libc++abi library.


Package: libc++-helpers
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: libc++-dev (<< 1.0~svn199600-1)
Breaks: libc++-dev (<< 1.0~svn199600-1)
Description: LLVM C++ Standard library - build helpers
 libc++ is a new implementation of the C++ standard library, targeting C++11.
 .
 Features and Goals
 .
   * Correctness as defined by the C++11 standard.
   * Fast execution.
   * Minimal memory use.
   * Fast compile times.
   * ABI compatibility with gcc's libstdc++ for some low-level features such
     as exception objects, rtti and memory allocation.
   * Extensive unit tests.
 .
 This package contains the build helpers (clang++-libc++, etc)
