=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
SRC_VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')

%:
	dh $@

override_dh_auto_clean:
	cd libcxxabi/test; \
		rm -f a.out
	cd libcxxabi/lib; \
		rm -f libc++abi.a libc++abi.so.1.0 libc++abi.so libc++abi.so.1 *.o
	cd libcxx/lib; \
		rm -f libc++.a libc++.so.1.0 libc++.so libc++.so.1.0 libc++.so.1 *.o

override_dh_auto_build:
	cd libcxxabi/lib && \
		rm -f libc++abi.so libc++abi.so.1 && \
		./buildit && \
		ln -s libc++abi.so.1.0 libc++abi.so && \
		ln -s libc++abi.so.1.0 libc++abi.so.1

	cd libcxx/lib && \
		rm -f libc++.so libc++.so.1 && \
		./buildit && \
		rm -f libc++.so libc++.so.1 && \
		ln -s libc++.so.1.0 libc++.so && \
		ln -s libc++.so.1.0 libc++.so.1

.PHONY: get-orig-source
get-orig-source:
	sh debian/libc++-get-orig-source.sh $(SRC_VERSION)
