## libc++ 3.9.1

=== debian/changelog ===
libc++ (3.9.1-2) unstable; urgency=medium

  * Silent a few tests on some archs to make the testsuite green.
    The testsuites are more than 5000 tests. We can live with ignoring a few
    tests.
    (Closes: #823058) even if it was a different issue
  * Remove useless libc++1.postinst, libc++1.postrm, libc++abi1.postinst
    and libc++abi1.postrm
  * Add debian/watch to detect new upstream release (but should
    not be used to retrieve sources)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 10 Jan 2017 16:45:20 +0100

libc++ (3.9.1-1) unstable; urgency=medium

  * New upstream release
  * Fix the FTBFS with dpkg-buildpackage -A (Closes: #849570)
    Thanks to Santiago Vila for the patch

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 29 Dec 2016 11:09:43 +0100

libc++ (3.9.0-3) unstable; urgency=medium

  * Team upload
  * Add missing Replaces dependency to libc++abi-dev (Closes: #843027)
  * Fix arm EHABI code to allow exceptions on armhf
  * Fix some unit test on different architectures

 -- Pauli <suokkos@gmail.com>  Thu, 03 Nov 2016 23:49:34 +0200

libc++ (3.9.0-2) unstable; urgency=medium

  * Team upload
  * Fix libc++abi-dev header paths (Closes: #800492, #806692)
  * Use cmake build system that should be easier to port to newer versions
  * Build libc++experimental.a for c++17 features with unstable ABI
  * Remove hardcoded ldconfig invocations from postinst&postrm
  * Bugs fixed with 3.9.0 release (Closes: #808086, #801303, #841594)

  [ Sylvestre Ledru ]
  * Remove pyc from the deb packages
  * Fix the copyright file

 -- Pauli <suokkos@gmail.com>  Tue, 01 Nov 2016 17:27:02 +0200

libc++ (3.9.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release (Closes: #837608)

  [ Sylvestre Ledru ]
  * Standards-Version updated to 3.9.8

 -- Pauli <suokkos@gmail.com>  Mon, 31 Oct 2016 12:56:19 +0200
