=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: libc++
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
+Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Andrej Belym <white.wolf.2105@gmail.com>,
  Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 9.0.0), clang, dh-exec
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9.0.0), cmake, clang-3.9 (>= 1:3.9-5), dh-exec, llvm-3.9-tools,
+ locales-all
+Standards-Version: 3.9.8
 Section: libs
 Homepage: http://libcxx.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/libcxx/trunk/
@@ -92,6 +92,8 @@
 Architecture: any
 Multi-Arch: same
 Depends: libc++abi1 (= ${binary:Version}), ${misc:Depends}
+Replaces: libc++-dev (<< 3.9.0-3)
+Breaks: lic++-dev (<< 3.9.0-3)
 Description: LLVM low level support for a standard C++ library (development files)
  libc++abi is a new implementation of low level support for a standard C++
  library.
